<template>
  <div class="page-container h-screen">
    <PageTitle v-if="!embedded" :title="`${translate('labels.create')} ${translate('users.user')}`" />

    <div class="flex flex-col px-8">
      <v-form ref="form" validate-on="submit lazy" @submit.prevent>
        <v-card>
          <div class="grid lg:grid-cols-2 gap-x-6">
            <v-select
              v-show="!embedded"
              id="available-types-select"
              v-model="data.type"
              :items="types"
              item-title="label"
              item-value="key"
              :rules="[(v: String) => !!v || translate('validation.type_required')]"
              :label="translate('types.select.label')"
              required
              @update:modelValue="typeChanged"
              :menu-icon="payrollConnectedUser.type === TypesEnum.TYPE_COMPANY ? '' : '$dropdown'"
              :disabled="payrollConnectedUser.type === TypesEnum.TYPE_COMPANY"
              density="compact"
            ></v-select>

            <v-text-field
              v-model="data.first_name"
              :label="translate('labels.first_name')"
              :rules="validator.setRules('required|min:2|max:50').validate()"
            ></v-text-field>

            <v-text-field
              v-model="data.last_name"
              :label="translate('labels.last_name')"
              :rules="validator.setRules('required|min:2|max:50').validate()"
            ></v-text-field>

            <v-text-field
              v-model="data.email"
              :label="translate('labels.email')"
              :rules="validator.setRules('required|email').validate()"
            ></v-text-field>

            <v-select
              id="available-languages-select"
              v-model="data.language_iso_code"
              :items="languages"
              item-title="label"
              item-value="language_iso_code"
              :rules="validator.setRules('required').validate()"
              :label="translate('language_selections.label')"
            ></v-select>

            <div
              v-if="
                            data.type === TypesEnum.TYPE_ADMIN || payrollConnectedUser.type === TypesEnum.TYPE_COMPANY
                        "
            >
              <v-select
                v-for="(client, index) in selectableClients"
                v-bind:key="client.id"
                v-model="data.role_id[index]"
                :items="client.roles"
                item-title="description"
                item-value="id"
                :rules="validator.setRules('required').validate()"
                :label="translate('roles.select.label')"
                hide-details="auto"
                density="compact"
              ></v-select>
            </div>
          </div>
          <Company
            v-show="!embedded"
            v-if="data.type === TypesEnum.TYPE_COMPANY && payrollConnectedUser.type !== TypesEnum.TYPE_COMPANY"
            :selectableClients="selectableClients"
            @update:model-value="updateRoles"
          ></Company>
        </v-card>

      </v-form>

      <div v-if="!embedded" class="flex flex-col items-end py-4">
        <v-btn type="submit" color="primary" @click="create" :prepend-icon="'mdi-content-save-outline'">
          {{ translate('labels.save') }}
        </v-btn>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, onMounted, onBeforeMount, defineProps, defineEmits, computed } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRouter } from 'vue-router'
import { storeFactory } from '@/main'
import { UserFormEvents } from '@/events/UserFormEvents'
import { Validator } from '@/helpers/Validator'
import type { Client } from '@/types/stores/userStoreTypes'
import { Types } from '@/enums/apiEnum'
import { TypesEnum } from '@/enums/userEnum'
import { DateTimeHelper } from '@/helpers/DateTimeHelper'
import type { AddressResource } from '@/types/stores/addressStoreTypes'
import { RelationsEnum } from '@/enums/relationsEnum'

// Components
import PageTitle from '@/components/page/PageTitle.vue'
import Company from '@/components/Company.vue'

const props = defineProps<{
  type?: string;
  embedded?: boolean;
}>()
const emit = defineEmits(['changed:type', 'success:newUser'])

const router = useRouter()
const { t: translate } = useI18n()

const countryStore = storeFactory.countryStore
const defaultValuesStore = storeFactory.defaultValuesStore
const userStore = storeFactory.userStore
const typeStore = storeFactory.typeStore

const events: UserFormEvents = new UserFormEvents()

const form = ref(null) as any
const types = ref(defaultValuesStore.getDefaultUserTypes([TypesEnum.TYPE_EMPLOYEE]))
const languages = ref(defaultValuesStore.getLanguages())
const connectedUser = userStore.searchUserById(userStore.getLoggedInUser.id)
const payrollConnectedUser = ref(userStore.getUser())
const selectedClients = ref([] as Client[])
const countries: any = ref(countryStore.getCountries())
const addresses = ref([]) as any
const addressTypes = ref(null) as any
const addressTypesDropdown = ref([]) as any
const addressEmployee: AddressResource | any = {}
const dateTimeHelper = new DateTimeHelper()
const selectedClientIds = ref([])
const selectedRole = ref([]) as any

let dateBirth = ref(null) as any

if (Object.keys(payrollConnectedUser.value).length === 0) {
  connectedUser.then((response) => {
    payrollConnectedUser.value = response.data
  })
}

const employee = ref({
  nationality_id: '',
  national_identification_number: '',
  iban: '',
  bic: '',
  date_of_birth: dateBirth,
  phone_number: ''
})

const data = ref({
  first_name: '',
  last_name: '',
  email: '',
  role_id: [],
  language_iso_code: '',
  type: '',
  auth_id: ''
})

const validator = new Validator()

const visibleFields = ref({
  country_id: true,
  type: false,
  street: true,
  streetNumber: true,
  streetNumberExtension: true,
  city: true,
  postCode: true
})

const selectableClients = computed((): Client[] | [] => {
  if (selectedClients.value.length === 0) {
    return []
  }

  if (payrollConnectedUser.value.type === TypesEnum.TYPE_COMPANY) {
    let activeClient = selectedClients.value.find(
      (client: Client) => client.id === userStore.getClient.id
    ) as Client
    if (activeClient === undefined) {
      return []
    }
    return [activeClient]
  }

  return data.value.type === TypesEnum.TYPE_COMPANY
    ? selectedClients.value
    : [selectedClients.value.find((client: Client) => client.id === userStore.getClient.id) as Client]
})

const updateDate = (e: any) => {
  dateBirth = dateTimeHelper.formatDate(e)
}
onMounted(async () => {
  clients.then((response) => {
    response.data.selectedClientIds = selectedClientIds.value
    response.data.selectedRole = selectedRole.value
    selectedClients.value = response.data
    data.value.type = TypesEnum.TYPE_COMPANY
  })

  events.mount(data, props)
  events.register()
})
onBeforeMount(async () => {
  await Promise.all([initializeAddressTypes(), initializeCountries()])
})

const initializeAddressTypes = async () => {
  if (typeStore.getAddressTypes().length === 0) {
    addressTypes.value = await typeStore.searchTypes(Types.ADDRESS)
  }
  addressTypesDropdown.value = addressTypes.value.map((type: string) => ({
    key: type,
    label: translate(`types.address.${type}`)
  }))
  addAddress()
}
const initializeCountries = async () => {
  if (countryStore.getCountries().length === 0) {
    countries.value = (await countryStore.searchCountries()).items
  }
}

const addAddress = () => {
  addresses.value.push({
    type: addressTypes.value[0],
    street: '',
    street_number: '',
    street_number_extension: '',
    city: '',
    post_code: '',
    country_id: null
  } as AddressResource)
}

// availableTypes: addressTypes.value,
// addressTypesDropdown: addressTypesDropdown.value,

const updateAddress = (index: number | string, updatedAddress: AddressResource) => {
  const address = addresses.value[index]
  if (address) {
    address.type = updatedAddress.type
    address.street = updatedAddress.street
    address.street_number = updatedAddress.street_number ? Number(updatedAddress.street_number) : null
    address.street_number_extension = updatedAddress.street_number_extension
    address.city = updatedAddress.city
    address.post_code = updatedAddress.post_code
    address.country_id = updatedAddress.country_id
  }
}

const create = async () => {
  if (!(await form.value.validate())?.valid) {
    return false
  }

  if (await userStore.create(data.value)) {
    await router.push({
      name: 'users.index'
    })
  }
}

defineExpose({ create })

const updateRoles = (roles: any) => {
  data.value.role_id = roles
}
</script>
